#ifndef _AISA15_H_
#define _AISA15_H_

#ifdef __cplusplus
extern "C" {
#endif

// őXbg
#define	AISA15_MAX_SLOTS				16

// _Xbgw
#define	AISA15_SLOT_AUTO				((WORD) ~0U)

// G[R[h̒`
#define	AISA15_ERR_INTERNAL				(-2)	// Send mail to us
#define	AISA15_ERR_UNKNOWN				(-1)	// Help me!
#define	AISA15_SUCCESS					0		// I
#define	AISA15_ERR_NO_DEVICE			1		// No device or not an aISA-A15
#define	AISA15_ERR_RESOURCE				2		// Resource exhaustion
#define	AISA15_ERR_INV_ARG				3		// Invalid argument(s)
#define	AISA15_ERR_SLOT					100		// _Xbgԍsłi܂͌܂j
#define	AISA15_ERR_CHANNEL				101		// `lw肪sł
#define	AISA15_ERR_TIMER				102		// ^C}lsł
#define	AISA15_ERR_DMA_BUFFSIZE			103		// DMA]TCYsł
#define	AISA15_ERR_NOT_ENOUGH_MEM		104		// \ȃmۂł܂ł
#define	AISA15_ERR_DMA					105		// DMA͎gpł܂
#define	AISA15_ERR_NUMDATA				106		// w肳ꂽ̃f[^obt@ɑ݂܂
#define	AISA15_ERR_NO_CREATE			107		// foCXNGCgĂ܂
#define	AISA15_ERR_START				108		// X^[gɎs܂B
#define	AISA15_ERR_INV_FUNC				109		// Ȋ֐Ăяoł

// TvO[h̒`
											// START  SAMPLING	TRANSFER  CLK
#define	MODE_01		1						// soft	  single	port	  ---
#define	MODE_02		2						// soft	  single	port	  EXTRG
#define	MODE_03		3						// soft	  burst		port	  timer
#define	MODE_04		4						// soft	  burst		port	  EXTRG
#define	MODE_05		5						// soft	  burst		DMA		  timer
#define	MODE_06		6						// EXIN0  single	port	  ---
#define	MODE_07		7						// EXIN0  single	port	  EXTRG
#define	MODE_08		8						// EXIN0  burst		port	  timer
#define	MODE_09		9						// EXIN0  burst		port	  EXTRG
#define	MODE_10		10						// EXIN0  burst		DMA		  timer

// bZ[W
#define	WM_EOC						0x6401	// VOTvO̊
#define	WM_BUFF_HALF_FULL			0x6402	// VxDOobt@̃n[tt
#define	WM_BUFF_FULL				0x6403	// VxDOobt@̃t
#define	WM_BUFF_OVERFLOW			0x6404	// VxDOobt@̃I[o[t[
#define	WM_SAMPLING_OVERRUN			0x6405	// `lEI[gECNg̃I[o[
#define	WM_DMA_TC					0x6406	// DMA]

// I/O\[XzE
#define	AISA15_NMAX_MEM					9	// MAX_MEM_REGISTERS
#define	AISA15_NMAX_IO					20	// MAX_IO_PORTS
#define	AISA15_NMAX_IRQ					7	// MAX_IRQS
#define	AISA15_NMAX_DMA					7	// MAX_DMA_CHANNELS

// ***** I/O\[X\ *****
// YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
typedef struct _AISA15RESOURCE {
	WORD	wNumMemWindows;					// EBhE
	DWORD	dMemBase[AISA15_NMAX_MEM];		// EBhEJnAhX
	DWORD	dMemLength[AISA15_NMAX_MEM];	// EBhE
	WORD	wMemAttrib[AISA15_NMAX_MEM];	// EBhE
	WORD	wNumIOPorts;					// I/O|[g
	WORD	wIOPortBase[AISA15_NMAX_IO];	// I/O|[gJnAhX
	WORD	wIOPortLength[AISA15_NMAX_IO];	// I/O|[g
	WORD	wNumIRQs;						// IRQ
	BYTE	bIRQRegisters[AISA15_NMAX_IRQ];	// IRQԍ
	BYTE	bIRQAttrib[AISA15_NMAX_IRQ];	// IRQ
	WORD	wNumDMAs;						// DMA`l
	BYTE	bDMALst[AISA15_NMAX_DMA];		// DMA`l
	WORD	wDMAAttrib[AISA15_NMAX_DMA];	// DMA`l
	BYTE	bReserved1[3];					// \
} AISA15RESOURCE, *PAISA15R;


// ***** TvO[h\ *****
// YfoCX̃TvO[hɊւVxD֓n߂̍\́B
// iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
typedef struct _AISA15MODE {
	DWORD	iChFirst;		// TvOJn`l(0 ` 15)
	DWORD	iChLast;		// TvOI`l(0 ` 15)
	DWORD	cwBuffer;		// obt@TCYi[hPʁj
	DWORD	dwTimer;		// ^C}l(1`50000000)
	DWORD	dwMode;			// 샂[h(1`10)
} AISA15MODE, *PCAISA15M;


// foCX̎gp錾
BOOL
WINAPI
Aisa15Create(
	LPWORD		lpwLogSlot,				// _Xbgw
	HWND		hwnd,					// bZ[W󂯎EBhEnh
	LPVOID		lpvInitArg);			// ̂߂̗\


// foCX̊J錾
BOOL
WINAPI
Aisa15Close(
	WORD		wLogSlot);				// _Xbgw


// foCXhCoDLL̃o[W擾
BOOL
WINAPI
Aisa15GetVersion(
	LPDWORD		lpdwDllVer,				// DLL̃o[W
	LPDWORD		lpdwDrvVer);			// VxD̃o[W


// I/O\[X̎擾
BOOL
WINAPI
Aisa15GetResource(
	WORD		wLogSlot,				// _Xbg
	PAISA15R	pres);					// \[X


// TvO[h̐ݒ
BOOL
WINAPI
Aisa15SetMode(
	WORD		wLogSlot,				// _Xbg
	PCAISA15M	pcmode);				// [hݒf[^


// TvOJn
BOOL
WINAPI
Aisa15StartSampling(
	WORD		wLogSlot);				// _Xbg


// TvO~
BOOL
WINAPI
Aisa15StopSampling(
	WORD		wLogSlot);				// _Xbg


// TvOEXe[^X̎擾
BOOL
WINAPI
Aisa15GetSamplingStatus(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpcwNumData,			// f[^obt@|C^
	LPDWORD		lpdwStatus);			// Xe[^X


// TvOς݃f[^̎擾
BOOL
WINAPI
Aisa15GetData(
	WORD		wLogSlot,				// _Xbg
	DWORD		cwNumData,				// vf[^
	LPWORD		lpwData);				// f[^obt@ւ̃|C^


// G[R[h̎擾
DWORD
WINAPI
Aisa15GetLastError(
	WORD		wLogSlot);				// _Xbg


// O͏Ԃ̎擾
BOOL
WINAPI
Aisa15GetExIn(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpdwExIn0,				// EXIN0̏
	LPDWORD		lpdwExIn1,				// EXIN1̏
	LPDWORD		lpdwExTrg);				// EXTRG̏


#ifdef __cplusplus
}
#endif

#endif
